;-----------------------------------------------------------------
;*****************************************************************
;**************     C.KOHLER 	SFX ROUTINE	       ***********
;*****************************************************************
;-----------------------------------------------------------------
ORG $20000
LOAD $20000
;-----------------------------------------------------------------
ST:
;----------------------------------------------------------------
	LEA	$50000,A0	; ERASE MEM
	MOVE.W	#$FFFE,D0
ERASE1:	MOVE.W	#0,(A0)+
DBRA	D0,ERASE1
;----------------------------------------------------------------
	MOVE.W	#0,$DFF064
	MOVE.W	#6,$DFF066
	MOVE.L	#$09F00000,$DFF040
	MOVE.L	#$FFFFFFFF,$DFF044
;----------------------------------------------------------------
	MOVE.L	#O,$DFF050		
	MOVE.L	#$4FF00,$DFF054
	MOVE.W	#7*64+20,$DFF058
	BSR	TEST
;----------------------------------------------------------------
	LEA	DEG,A0		
	MOVE.W	#176,D4	
	MOVE.B	#$4C,D0		
CONSTRUIT_COPPER:		
	MOVE.B	D0,(A0)+	
	MOVE.B	#$E1,(A0)+	
	MOVE.W	#$FFFE,(A0)+	
	MOVE.L	#$01820000,(A0)+
	MOVE.L	#$01020000,(A0)+
	ADD.B	#1,D0		
	DBRA	D4,CONSTRUIT_COPPER
;----------------------------------------------------------------
	BSR	SAVE_ALL		; FORBID & SAVE POINTEURS
	BSR	INIT_MUSIC		; INIT MUSIC
;----------------------------------------------------------------
	CMP.W	#1,PASSE_ONE		; CONVERT TEXT
	BEQ	CONS
	BSR	TRANSTEXT
;----------------------------------------------------------------
CONS:	BSR	CONS_FIRST
;---------------------------------------------------------------
INIT:
	LEA	$DFF000,A6	
	MOVE.W	#$7FFF,$9A(A6)	
	MOVE.W	#$7FFF,$96(A6)	
	MOVE.L	#$026439D1,$8E(A6)
	MOVE.W	#$1200,$100(A6)	
	CLR.L	$102(A6)	
	MOVE.L	#$00060006,$DFF108
	MOVE.L	#$003800D0,$92(A6)
	MOVE.L	#COPP,$DFF080
	CLR.W	$DFF088
;---------------------------------------------------------------
	MOVE.L	#IRQ,$6C	
	MOVE.W	#%1100000000010000,$9A(A6)
	MOVE.W	#%1000001111000000,$96(A6)
;---------------------------------------------------------------
ATTEN:				
	BTST	#6,$BFE001	
	BNE	ATTEN		
	BSR	RESTORE_ALL	
	BSR	END_MUSIC
RTS
;----------------------------------------------------------------
IRQ:
	MOVE.L	D0,-(SP)	
	MOVE.W	$DFF01C,D0	
	AND.W	$DFF01E,D0	
	BTST	#4,D0		
	BEQ	FINIRQ		

	BSR	EFF
	BSR	SCR			
	BSR	SCROLL_COLOR
	BSR	SCROLL_COLOR_FOND
	BSR	SCROLL_COLOR_D

	BSR	PLAY_MUSIC		

	BSR	AFFICHE_LETTRES
;----------------------------------------------------------------
	MOVE.W	$DFF00C,D0	; PREND DATAS JOY

	BTST	#1,D0		; TEST JOY DROITE
	BEQ	PAS_RIGHT
	MOVE.W	#1,OK_PLAY
PAS_RIGHT:

;	BTST	#9,D0		; TEST JOY GAUCHE
;	BEQ	PAS_LEFT
;	BSR	STOP_DIGIT
;PAS_LEFT:
	MOVE.W	#$10,$DFF09C
FINIRQ:
	MOVE.L	(SP)+,D0
RTE
;---------------------------------------------------------------
;		SORT UN SON ECHANTILLONNE
;---------------------------------------------------------------
PLAY_DIGIT:
	MOVE.W	#$0001,$DFF096			; ETEINT VOIE

	MOVE.W	#200,D0
LOOP1:	DBF	D0,LOOP1

	MOVE.W	#1600/2,$DFF0A4			; LENGHT
	MOVE.W	#64,$DFF0A8			; VOLUME
	MOVE.W	#800,$DFF0A6			; FRENQUENCE
	MOVE.L	#SAMPLE_LAZER,$DFF0A0		; POINTEUR DONNEE

	MOVE.W	#$8001,$DFF096			; LANCE DMA VOICE1
	MOVE.W	#13,VOICE1SFX			; DUREE EN 50EME DE SEC
	MOVE.W	#0,OK_PLAY			; ET ETEINT SWITCH
	
	MOVE.W	#50,D0
LOOP:	DBF	D0,LOOP

	MOVE.L	#VIDE,$DFF0A0			; POINTEUR DONNEE
	MOVE.W	#1,$DFF0A4			; LENGHT
RTS

STOP_DIGIT:
	MOVE.W	#0,OK_PLAY			; ETEINT SWITCH
RTS

VIDE:		DC.W	0,0,0
VOICE1SFX:	DC.W	0
OK_PLAY:	DC.W	0
;---------------------------------------------------------------
;	ROUTINE GENIAL QUI AFFICHE UN REGISTRE EN MOT
;---------------------------------------------------------------
AFFICHE_LETTRES:

;	PARAMETRES:
;	A0 >> ADRESSE ECRAN	
;	A3 >> ADRESSE DU MOT A AFFICHER

	LEA	$60000,A0		; DEPART AFFICHAGE
	MOVE.L	$70000,A3		; PREND VALEUR A CONVERTIR
	BSR	AFFICHE_L

	LEA	$60006,A0		; DEPART AFFICHAGE
	MOVE.L	#VOICE1SFX,A3		; PREND VALEUR A CONVERTIR
	BSR	AFFICHE_L
RTS
;---------------------------------------------------------------
PLUS_G:
	CMP.W	#$A,D1
	BMI	OK_G
	ADD.W	#7,D1
OK_G:
RTS
;---------------------------------------------------------------
AFFICHE_L:
;---------------------------------------------------------------
	MOVE.W	(A3),D3			; PREND VALEUR
;---------------------------------------------------------------
	MOVE.W	D3,D1			; LOAD IT
	LSR.W	#8,D1
	LSR.W	#4,D1
	AND.W	#$000F,D1		; GARDE PREMIER
	BSR	PLUS_G
	BSR	DODO			; CALCUL 1 EME CHIFFRE

	MOVE.W	D3,D1			; LOAD IT
	LSR.W	#8,D1
	AND.W	#$000F,D1		; GARDE PREMIER
	BSR	PLUS_G
	BSR	DODO			; CALCUL 2 EME CHIFFRE

	MOVE.W	D3,D1			; LOAD IT
	LSR.W	#4,D1
	AND.W	#$000F,D1		; GARDE PREMIER
	BSR	PLUS_G
	BSR	DODO			; CALCUL 3 EME CHIFFRE

	MOVE.W	D3,D1			; LOAD IT
	AND.W	#$000F,D1		; GARDE PREMIER
	BSR	PLUS_G
	BSR	DODO			; CALCUL 4 EME CHIFFRE
;---------------------------------------------------------------
RTS
;		AFFICHE_CARACTERE	; 
DODO:
	MOVE.L	A0,A2			; SAUVE ADDRESSE DE DEPART
;---------------------------------------------------------------
	ADD.W	#16,D1
	MULU	#8,D1
	LEA	LITTLE_FONT,A1
	ADD.L	D1,A1
;---------------------------------------------------------------
	MOVE.W	#7,D0		; AFFICHE T EN A0
DT:	MOVE.B	(A1)+,(A2)	; BOUCLE AFFICHAGE
	ADD.L	#40,A2
	DBRA	D0,DT
;---------------------------------------------------------------
	ADD.L	#1,A0
RTS
;---------------------------------------------------------------
; SCROLL PRINCIPAUX.
;---------------------------------------------------------------
VITESSE0:DC.W	$F
VITESSE1:DC.W	$8
;---------------------------------------------------------------
SCR:					; 2 SCROLLS
	BSR	SCROLLY
	ADD.W	#1,CHAPI_CHAPO	
	MOVE.W	VITESSE0,D0
	MOVE.W	CHAPI_CHAPO,D1
	CMP.W	D1,D0
	BNE	SUITE_LIS
	MOVE.W	#0,CHAPI_CHAPO
	BSR	LIS
SUITE_LIS:
	BSR	SCROLLY1
	ADD.W	#1,CHAPI_CHAPO1	
	MOVE.W	VITESSE1,D0
	MOVE.W	CHAPI_CHAPO1,D1
	CMP.W	D0,D1
	BNE	SUITE_LIS1
	MOVE.W	#0,CHAPI_CHAPO1
	BSR	LIS1
SUITE_LIS1:
RTS
;---------------------------------------------------------------
CHAPI_CHAPO:DC.W	0
CHAPI_CHAPO1:DC.W	0
;---------------------------------------------------------------
COMPTEUR_SCROLLY:DC.W	0
;---------------------------------------------------------------
; COMPTEUR SUR TABLES (COLORS VERT,COLOR HORIZONTALES ET DECALAGE)
;---------------------------------------------------------------
C_COLOR:DC.W	-2
C_COLOR1:DC.W	-2
C_COLOR2:DC.W	-2
C_COLOR3:DC.W	-2
C_COLORC:DC.W	-2
C_COLORD:DC.W	-2
;---------------------------------------------------------------
; SCROLL DES COLOR DANS LES LIGNES VERTICALES.
;---------------------------------------------------------------
SCROLL_COLOR:
	LEA	C_COLOR,A0
	LEA	D_COLOR,A1
	LEA	T_COLOR,A2
	LEA	COLOR,A3
	BSR	SCROLL_C

	LEA	C_COLOR1,A0
	LEA	D_COLOR1,A1
	LEA	T_COLOR1,A2
	LEA	COLOR1,A3
	BSR	SCROLL_C1
		
	LEA	C_COLOR2,A0
	LEA	D_COLOR2,A1
	LEA	T_COLOR2,A2
	LEA	COLOR2,A3
	BSR	SCROLL_C

	LEA	C_COLOR3,A0
	LEA	D_COLOR3,A1
	LEA	T_COLOR3,A2
	LEA	COLOR3,A3
	BSR	SCROLL_C1
RTS
;---------------------------------------------------------------
SCROLL_C:
	ADD.W	#2,(A0)
	MOVE.W	(A0),D0

	MOVE.W	(A1,D0.W),D0

	CMP.W	#$FFFF,D0
	BNE	BON_C

	MOVE.W	#-2,(A0)
	BRA	SCROLL_C
BON_C:
	move.W	#0,$dff064
	move.W	#0,$dff066
	move.l	#$09f00000,$dff040
	move.l	#$ffffffff,$dff044
;----------------------------------------------------------------
	ADD.L	#2,A2
	move.l	A2,$dff050		; COPY LOGO TO WORKMEM
	SUB.L	#2,A2
	move.l	A2,$dff054
	move.w	#1*64+24,$dff058
	BSR	TEST
	
	MOVE.W	D0,46(A2)	

	MOVE.W	#23,D0
DD:
	MOVE.W	(A2)+,2(A3)	
	ADD.W	#4,A3
	DBRA	D0,DD	
RTS
;---------------------------------------------------------------
SCROLL_C1:
	ADD.W	#2,(A0)
	MOVE.W	(A0),D0

	MOVE.W	(A1,D0.W),D0

	CMP.W	#$FFFF,D0
	BNE	BON_C1

	MOVE.W	#-2,(A0)
	BRA	SCROLL_C1
BON_C1:
	move.W	#0,$dff064
	move.W	#0,$dff066
	move.l	#$09f00000,$dff040
	move.l	#$ffffffff,$dff044
;----------------------------------------------------------------
	SUB.L	#2,A2
	move.l	A2,$dff050
	ADD.L	#2,A2
	move.l	A2,$dff054
	move.w	#1*64+24,$dff058
	BSR	TEST
	
	MOVE.W	D0,(A2)	

	MOVE.W	#23,D0
DD1:
	MOVE.W	(A2)+,2(A3)	
	ADD.W	#4,A3
	DBRA	D0,DD1	
RTS
;---------------------------------------------------------------
SCROLLY:
	SUB.W	#1,COMPTEUR_SCROLLY
	BMI 	MAKE_IT
BRA	FIN_SCROLLY

MAKE_IT:MOVE.W	#0,COMPTEUR_SCROLLY
	MOVE.L	#$4002A+2,$DFF050
	MOVE.L	#$4002A+0,$DFF054
	MOVE.W	#0,$DFF064
	MOVE.W	#0,$DFF066

	LEA	DECALAGE0,A3
	MOVE.L	(A3),$DFF040

	MOVE.L	#$FFFFFFFF,$DFF044
	MOVE.W	#16*64+22,$DFF058
BSR	TEST
FIN_SCROLLY:
RTS
;---------------------------------------------------------------
DECALAGE0:DC.L	$F9F00000
DECALAGE1:DC.L	$E9F00000
;---------------------------------------------------------------
COMPTEUR_SCROLLY1:DC.W	0
;---------------------------------------------------------------
SCROLLY1:
	SUB.W	#1,COMPTEUR_SCROLLY1
	BMI 	MAKE_IT1
BRA	FIN_SCROLLY1

MAKE_IT1:
	MOVE.W	#0,COMPTEUR_SCROLLY1

	MOVE.L	#$4102A+2,$DFF050
	MOVE.L	#$4102A+0,$DFF054
	MOVE.W	#0,$DFF064
	MOVE.W	#0,$DFF066

	LEA	DECALAGE1,A3
	MOVE.L	(A3),$DFF040
	MOVE.L	#$FFFFFFFF,$DFF044
	MOVE.W	#16*64+22,$DFF058
BSR	TEST
FIN_SCROLLY1:
RTS
;---------------------------------------------------------------
TEST:
	BTST	#6,$DFF002
	BNE	TEST
RTS
;---------------------------------------------------------------
TEST_EFFETS0:
	CMP.B	#$A1,D1
	BNE	TEST01
	MOVE.W	#$F,VITESSE0
	MOVE.L	#$F9F00000,DECALAGE0
	BRA	FIN_FIN_FIN	
TEST01:				
	CMP.B	#$A2,D1
	BNE	TEST02	
	MOVE.W	#8,VITESSE0
	MOVE.L	#$E9F00000,DECALAGE0
	BRA	FIN_FIN_FIN	
TEST02:			
	CMP.B	#$A3,D1
	BNE	TEST03
	MOVE.W	#4,VITESSE0
	MOVE.L	#$C9F00000,DECALAGE0
	BRA	FIN_FIN_FIN
TEST03:
	CMP.B	#$A4,D1
	BNE	TEST04
	MOVE.W	#$0,CHAPI_CHAPO
	MOVE.W	#2,VITESSE0
	MOVE.L	#$89F00000,DECALAGE0

	BRA	FIN_FIN_FIN
TEST04:
	CMP.B	#$A5,D1
	BNE	TEST05
	MOVE.W	#$0,CHAPI_CHAPO
	MOVE.W	#1,VITESSE0
	MOVE.L	#$19F00000,DECALAGE0
	BRA	FIN_FIN_FIN
TEST05:
	CMP.B	#$A6,D1
	BNE	TEST06
	MOVE.W	#200,COMPTEUR_SCROLLY
	BRA	FIN_FIN_FIN
TEST06:
BRA	CONT
;---------------------------------------------------------------
COMPTTEXT:DC.W	-1
;---------------------------------------------------------------
LIS:
	CMP.W	#0,COMPTEUR_SCROLLY
	BNE	FIN_FIN_FIN

	LEA	TEXTE,A0
	ADD.W	#1,COMPTTEXT

	MOVE.W	COMPTTEXT,D0

	CLR.W	D1
	MOVE.B	(A0,D0.W),D1

	CMP.B	#$FF,D1
	BNE	SUITE_SUITE_11
	MOVE.W	#-1,COMPTTEXT
	BRA	LIS
SUITE_SUITE_11:
	BRA	TEST_EFFETS0
CONT:	LEA	ADDRESSE,A4
	MULU	#2,D1

	MOVE.W	(A4,D1.W),ABS
	LEA	POL,A0
	ADD.W	ABS,A0

	MOVE.L	A0,$DFF050
	MOVE.L	#$4002E+42,$DFF054
	MOVE.W	#38,$DFF064
	MOVE.W	#44,$DFF066
	MOVE.L	#$09F00000,$DFF040
	MOVE.L	#$FFFFFFFF,$DFF044
	MOVE.W	#16*64+1,$DFF058
BSR	TEST
FIN_FIN_FIN:
RTS
;----------
EFF:	MOVE.L	#$4D000,$DFF050
	MOVE.L	#$4002E-2,$DFF054
	MOVE.W	#38,$DFF064
	MOVE.W	#44,$DFF066
	MOVE.L	#$09F00000,$DFF040
	MOVE.L	#$FFFFFFFF,$DFF044
	MOVE.W	#16*64+1,$DFF058
BSR	TEST
	MOVE.L	#$4D000,$DFF050
	MOVE.L	#$4102E-2,$DFF054
	MOVE.W	#38,$DFF064
	MOVE.W	#44,$DFF066
	MOVE.L	#$09F00000,$DFF040
	MOVE.L	#$FFFFFFFF,$DFF044
	MOVE.W	#16*64+1,$DFF058
BSR	TEST
RTS
;---------------------------------------------------------------
TEST_EFFETS1:
	CMP.B	#$A1,D1
	BNE	TEST1
	MOVE.W	#$F,VITESSE1
	MOVE.W	#$D,CHAPI_CHAPO1
	MOVE.L	#$F9F00000,DECALAGE1
	BRA	FIN_FIN_FIN1	
TEST1:	CMP.B	#$A2,D1
	BNE	TEST2	
	MOVE.W	#8,VITESSE1
	MOVE.W	#$6,CHAPI_CHAPO1
	MOVE.L	#$E9F00000,DECALAGE1
	BRA	FIN_FIN_FIN1	
TEST2:	CMP.B	#$A3,D1
	BNE	TEST3
	MOVE.W	#$2,CHAPI_CHAPO1
	MOVE.W	#4,VITESSE1
	MOVE.L	#$C9F00000,DECALAGE1
	BRA	FIN_FIN_FIN1
TEST3:	CMP.B	#$A4,D1
	BNE	TEST4
	MOVE.W	#$0,CHAPI_CHAPO1
	MOVE.W	#2,VITESSE1
	MOVE.L	#$89F00000,DECALAGE1
	BRA	FIN_FIN_FIN1
TEST4:	CMP.B	#$A5,D1
	BNE	TEST5
	MOVE.W	#$0,CHAPI_CHAPO1
	MOVE.W	#1,VITESSE1
	MOVE.L	#$19F00000,DECALAGE1
	BRA	FIN_FIN_FIN1
TEST5:	CMP.B	#$A6,D1
	BNE	TEST6
	MOVE.W	#200,COMPTEUR_SCROLLY1
	BRA	FIN_FIN_FIN1
TEST6:	BRA	CONT1
;---------------------------------------------------------------
COMPTTEXT1:DC.W	-1
;---------------------------------------------------------------
LIS1:	CLR.L	D0
	CMP.W	#0,COMPTEUR_SCROLLY1
	BNE	FIN_FIN_FIN1
	LEA	TEXTE1,A0
	ADD.W	#1,COMPTTEXT1
	MOVE.W	COMPTTEXT1,D0
	CLR.W	D1
	MOVE.B	(A0,D0.W),D1
	CMP.B	#$FF,D1
	BNE	SUITE_SUITE_111
	MOVE.W	#-1,COMPTTEXT1
	BRA	LIS1
SUITE_SUITE_111:
	BRA	TEST_EFFETS1
CONT1:	LEA	ADDRESSE,A4
	MULU	#2,D1
	MOVE.W	(A4,D1.W),ABS
	LEA	POL,A0
	ADD.W	ABS,A0
	MOVE.L	A0,$DFF050
	MOVE.L	#$4102E+42,$DFF054
	MOVE.W	#38,$DFF064
	MOVE.W	#44,$DFF066
	MOVE.L	#$09F00000,$DFF040
	MOVE.L	#$FFFFFFFF,$DFF044
	MOVE.W	#16*64+1,$DFF058
BSR	TEST
FIN_FIN_FIN1:
RTS
;---------------------------------------------------------------
ABS:DC.W	0
;---------------------------------------------------------------
TRANSTEXT:
	CLR.L 	D0
	LEA 	CODETABLE,A0
	LEA	TEXTE,A1
	BSR	DO_TRANS
	CLR.L 	D0
	LEA 	CODETABLE,A0
	LEA	TEXTE1,A1
	BSR	DO_TRANS
	CLR.L 	D0
	LEA 	CODETABLE,A0
	LEA	TEXTE_CONS,A1
	BSR	DO_TRANS
	MOVE.W	#1,PASSE_ONE
RTS
;---------------------------------------------------------------
DO_TRANS:
TT1:	CLR.L	D1
	MOVE.B	(A1),D1
	MOVE.B 	(A0),D0
	CMP.B 	(A1),D0
	BNE 	TT2
	MOVE.B 	1(A0),(A1)
TT3:	CMP.B 	#255,(A1)
	BEQ 	ENDTT
	LEA 	CODETABLE,A0
	ADD 	#1,A1
	BRA 	TT1
TT2:	ADD 	#2,A0
	BRA TT1
ENDTT:
RTS
;---------------------------------------------------------------
PASSE_ONE:DC.W	0	; DEJA CONVERTI TEXT =1
;----------------------------------------------------------------
SAVE_ALL:
	MOVE.B #$87,$BFD100		; STOP DRIVE
	MOVE.L $00000004,A6
	JSR -132(A6)
	MOVE.L $6C,SAVEIRQ
	MOVE.W $DFF01C,SAVEINT
	OR.W #$C000,SAVEINT
	MOVE.W $DFF002,SAVEDMA
	OR.W #$8100,SAVEDMA
RTS
;---------------------------------------------------------------
C_CONS:DC.W	-1
;---------------------------------------------------------------
CONS_FIRST:
	MOVE.W	#38,$DFF064
	MOVE.W	#44,$DFF066
	MOVE.L	#$09F00000,$DFF040
	MOVE.L	#$FFFFFFFF,$DFF044

	LEA	$45000,A4
	LEA	$45000,A3

	MOVE.W	#8,D4
SECOND_PASS:
	MOVE.W	#19,D5
FIRST_PASS:
	CLR.L	D0
	LEA	TEXTE_CONS,A0
	ADD.W	#1,C_CONS
	MOVE.W	C_CONS,D0
	CLR.L	D1
	MOVE.B	(A0,D0.W),D1
CONS_SUITE:
	LEA	ADDRESSE,A2
	MULU	#2,D1
	MOVE.W	(A2,D1.W),ABS
	LEA	POL,A0
	ADD.W	ABS,A0
	MOVE.L	A0,$DFF050
	MOVE.L	A3,$DFF054
	MOVE.W	#16*64+1,$DFF058
BSR	TEST
	ADD.L	#2,A3
DBRA	D5,FIRST_PASS
	ADD.L	#46*19,A4
	MOVE.L	A4,A3
DBRA	D4,SECOND_PASS
FIN_FIN_FIN_CONS:
RTS
;----------------------------------------------------------------
; SCROLL DES DECALAGE DU FOND .
;----------------------------------------------------------------
DO_ITD:DC.W	0
;----------------------------------------------------------------
SCROLL_COLOR_D:
	ADD.W	#1,DO_ITD
	CMP.W	#2,DO_ITD
	BEQ	GOODD
	BRA	BIBID
GOODD:	CLR.W	DO_ITD
	LEA	C_COLORD,A0
	LEA	D_COLORD,A1
	LEA	T_COLORD,A2
	LEA	DEG,A3
SCROLL_CCD:
	ADD.W	#2,(A0)
	MOVE.W	(A0),D0
	MOVE.W	(A1,D0.W),D0
	CMP.W	#$FFFF,D0
	BNE	BON_CCD
	MOVE.W	#-2,(A0)
	BRA	SCROLL_CCD
BON_CCD:
	move.W	#0,$dff064
	move.W	#0,$dff066
	move.l	#$09f00000,$dff040
	move.l	#$ffffffff,$dff044
	move.l	#T_COLORD+2,$dff050
	move.l	#T_COLORD,$dff054
	move.w	#1*64+352,$dff058
	BSR	TEST

	MOVE.W	D0,352(A2)	
	MOVE.W	#170,D0
	ADD.L	#10,A3
DDCD:	MOVE.W	(A2)+,(A3)	
	ADD.L	#12,A3
	DBRA	D0,DDCD
BIBID:
RTS
;----------------------------------------------------------------
; SCROLL DES COLOR DU FOND .
;----------------------------------------------------------------
DO_IT:DC.W	0
;----------------------------------------------------------------
SCROLL_COLOR_FOND:
	ADD.W	#1,DO_IT
	CMP.W	#2,DO_IT
	BEQ	GOOD
	BRA	BIBI
GOOD:	CLR.W	DO_IT
	LEA	C_COLORC,A0
	LEA	D_COLORC,A1
	LEA	T_COLORC,A2
	LEA	DEG,A3

SCROLL_CC:
	ADD.W	#2,(A0)
	MOVE.W	(A0),D0

	MOVE.W	(A1,D0.W),D0

	CMP.W	#$FFFF,D0
	BNE	BON_CC

	MOVE.W	#-2,(A0)
	BRA	SCROLL_CC
BON_CC:
	move.W	#0,$dff064
	move.W	#0,$dff066
	move.l	#$09f00000,$dff040
	move.l	#$ffffffff,$dff044
	move.l	#T_COLORC+2,$dff050
	move.l	#T_COLORC,$dff054
	move.w	#1*64+352,$dff058
	BSR	TEST
	
	MOVE.W	D0,352(A2)	

	MOVE.W	#170,D0
	ADD.L	#6,A3
DDC:
	MOVE.W	(A2)+,(A3)	
	ADD.L	#12,A3
	DBRA	D0,DDC
BIBI:
RTS
;---------------------------------------------------------------
RESTORE_ALL:
	MOVE.L SAVEIRQ,$6C
	MOVE.W #$7FFF,$DFF09A	
	MOVE.W SAVEINT,$DFF09A
	MOVE.W #$7FFF,$DFF096
	MOVE.W SAVEDMA,$DFF096
	MOVE.L $00000004,A6
	LEA NAME,A1
	MOVEQ #0,D0
	JSR -552(A6)

	MOVE.L D0,A0
	MOVE.L 38(A0),$DFF080
	CLR.W $DFF088
	MOVE.L D0,A1
	JSR -414(A6)
	JSR -138(A6)
RTS
;---------------------------------------------------------------
SAVEINT:DC.W 0
SAVEDMA:DC.W 0
SAVEIRQ:DC.L 0
NAME:DC.B "graphics.library",0
EVEN
;----------------------------------------------------------------
; **
; ** CARACTERS AVAILABLE : 
; ** 
; ** ' , . : ( ) " " - ? ! 
; ** 
; ** ACCEPTE MINUSCULES ET MAJUSCULES ... 
; ** 
; ** VITESSE :      = [ALT] + [1] OU [2] ...... [5]
; **
; ** PAUSE   :  = [ALT] + [6]
; **
; ** AND MUST BE FINISHED BY $FF,$FF
; **

;----------------------------------------------------------------

TEXTE:
DC.B	"     HIP HOP!          VOICI LA ROUTINE SFX V1.0            " 
DC.B	" BASEE SUR LA ROUTINE 1.3 DE FUTURE COMPOSER    ........"
DC.B	"......."
DC.B	" POUR DIGIT ET SONS INTERNE : N'HESITEZ PLUS !!!!!!! "  
DC.B	"        APPELEZ MOI !       EHEHE                     "

DC.B	$FF,$FF
EVEN
;---------------------------------------------------------------
TEXTE1:
DC.B	"USE YOUR STICK POUR FAIRE DES EFFETS "
DC.B	" (FIRE ET POSITIONS DU JOY ..........) ................     "
DC.B 	$FF,$FF
EVEN
;---------------------------------------------------------------
TEXTE_CONS:
DC.B	"   SOUND FX RTINE   "			; 20 CARACTERES PAR 
DC.B	"   --------------   "			; LIGNE
DC.B	"  TAKE YOUR  STICK  "			; SINON .....
DC.B	"   ENJOY THE TRIP   " 
DC.B	"--------------------"
DC.B	"- BASED ON THE 1.3 -" 
DC.B	"- ET PAS 1.4 ENCOR -" 
DC.B	"--------------------" 
DC.B	" FAIT LE  26/11/90  " 
DC.B	$FF,$FF
EVEN
;---------------------------------------------------------------
PLAY_MUSIC:
BRA.L PLAY
;----------------------------------------------------------------
END_MUSIC:
	CLR.W ONOFF
	CLR.L $DFF0A6		; AUD0PE    PERIODE D'ECHANTILLON
	CLR.L $DFF0B6
	CLR.L $DFF0C6
	CLR.L $DFF0D6
	MOVE.W #$000F,$DFF096	; VIRE LES DMA	
	BCLR #1,$BFE001
RTS
;----------------------------------------------------------------
INIT_MUSIC:
	MOVE.W #1,ONOFF
	BSET #1,$BFE001
	LEA MODULE,A0
	LEA 100(A0),A1
	MOVE.L A1,SEQPOINT		; POINTEUR SEQUENCE
	MOVE.L A0,A1
	ADD.L 8(A0),A1
	MOVE.L A1,PATPOINT		; POINTEUR PATERN
	MOVE.L A0,A1
	ADD.L 16(A0),A1
	MOVE.L A1,FRQPOINT		; SONS POINTEUR ???
	MOVE.L A0,A1
	ADD.L 24(A0),A1
	MOVE.L A1,VOLPOINT		; VOLUME POINTEUR
	MOVE.L 4(A0),D0
	DIVU #13,D0
	LEA 40(A0),A1
	LEA SOUNDINFO+4(PC),A2
	MOVEQ #10-1,D1
INITLOOP:
	MOVE.W (A1)+,(A2)+
	MOVE.L (A1)+,(A2)+
	ADDQ.W #4,A2
DBF D1,INITLOOP
	MOVEQ #0,D2
	MOVE.L A0,D1
	ADD.L 32(A0),D1
	SUB.L #WAVEFORMS,D1
	LEA SOUNDINFO(PC),A0
	MOVE.L D1,(A0)+
	MOVEQ #9-1,D3
INITLOOP1:
	MOVE.W (A0),D2
	ADD.L D2,D1
	ADD.L D2,D1
	ADDQ.W #6,A0
	MOVE.L D1,(A0)+
	DBF D3,INITLOOP1
	MOVE.L SEQPOINT(PC),A0
	MOVEQ #0,D2
	MOVE.B 12(A0),D2		;GET REPLAY SPEED
	BNE.S SPEEDOK
	MOVE.B #3,D2			;SET DEFAULT SPEED
SPEEDOK:
	MOVE.W D2,RESPCNT		;INIT REPSPEED COUNTER
	MOVE.W D2,REPSPD
INIT2:	CLR.W AUDTEMP
	MOVE.W #$000F,$DFF096		;DISABLE AUDIO DMA
	MOVE.W #$0780,$DFF09A		;DISABLE AUDIO IRQ
	MOVEQ #0,D7
	MULU #13,D0
	MOVEQ #4-1,D6			;NUMBER OF SOUNDCHANNELS-1
	LEA V1DATA(PC),A0		;POINT TO 1ST VOICE DATA AREA
	LEA SILENT(PC),A1
	LEA O4A0C8(PC),A2
INITLOOP2:
	MOVE.L A1,10(A0)
MOVE.L A1,18(A0)
	CLR.L 14(A0)
	CLR.B 45(A0)
	CLR.B 47(A0)
	CLR.W 8(A0)
	CLR.L 48(A0)
	MOVE.B #$01,23(A0)
	MOVE.B #$01,24(A0)
	CLR.B 25(A0)
	CLR.L 26(A0)
	CLR.W 30(A0)
	MOVEQ #$00,D3
	MOVE.W (A2)+,D1
	MOVE.W (A2)+,D3
	DIVU #$0003,D3
	MOVE.B D3,32(A0)
	MULU #$0003,D3
	ANDI.L #$00FF,D3
	ANDI.L #$00FF,D1
	ADDI.L #$DFF0A0,D1
	MOVE.L D1,A6
	MOVE.L #$0000,(A6)
	MOVE.W #$0100,4(A6)
	MOVE.W #$0000,6(A6)
	MOVE.W #$0000,8(A6)
	MOVE.L D1,60(A0)
	CLR.W 64(A0)
	MOVE.L SEQPOINT(PC),(A0)
	MOVE.L SEQPOINT(PC),52(A0)
	ADD.L D0,52(A0)
	ADD.L D3,52(A0)
	ADD.L D7,(A0)
	ADD.L D3,(A0)
	MOVE.W #$000D,6(A0)
	MOVE.L (A0),A3
	MOVE.B (A3),D1
	ANDI.L #$00FF,D1
	LSL.W #6,D1
	MOVE.L PATPOINT(PC),A4
	ADDA.W D1,A4
	MOVE.L A4,34(A0)
	CLR.L 38(A0)
	MOVE.B #$01,33(A0)
	MOVE.B #$02,42(A0)
	MOVE.B 1(A3),44(A0)
	MOVE.B 2(A3),22(A0)
	CLR.B 43(A0)
	CLR.B 45(A0)
	CLR.W 56(A0)
	ADDA.W #$004A,A0	;POINT TO NEXT VOICE'S DATA AREA
	DBF D6,INITLOOP2
RTS
;---------------------------------------------------------------
PLAY:	LEA PERVOL(PC),A6
	TST.W ONOFF
	BNE.S MUSIC_ON
RTS
;---------------------------------------------------------------
MUSIC_ON:
;---------------------------------------------------------------
	CMP.W	#0,VOICE1SFX		; PAS DE SAMPLES EN COURS
	BEQ	GOMUSIC			; ALORS CONTINUE MUSIC
;---------------------------------------------------------------
					; IL Y A UN SAMPLE EN COURS
	SUBQ.W	#1,VOICE1SFX		; DECREMENTE COMPTEUR 1/50 S
	CMP.W	#0,VOICE1SFX		; A 0 = DONC SAMPLE
	BNE.S	GOMUSIC			; FINI.
	CLR.W	OK_PLAY			; ET STOP SAMPLE
;---------------------------------------------------------------
GOMUSIC:
;---------------------------------------------------------------
	SUBQ.W #1,RESPCNT		;DECREASE REPLAYSPEED COUNTER
	BNE.S NONEWNOTE
	MOVE.W REPSPD(PC),RESPCNT	;RESTORE REPLAYSPEED COUNTER
;---------------------------------------------------------------
;CMP.W	#0,VOICE1SFX
;BNE	PAS_NEW_NOTE1

	LEA V1DATA(PC),A0		;POINT TO VOICE1 DATA AREA
	BSR.L NEW_NOTE

;	BRA	RETOUR_PAS_NEW_NOTE1
;PAS_NEW_NOTE1:
;	LEA V1DATA(PC),A0		;POINT TO VOICE1 DATA AREA
;	ADDQ.W 	#2,40(A0)
;	BSR.L NEW_NOTE1
;RETOUR_PAS_NEW_NOTE1:

;---------------------------------------------------------------
	LEA V2DATA(PC),A0		;POINT TO VOICE2 DATA AREA
	BSR.L NEW_NOTE
	LEA V3DATA(PC),A0		;POINT TO VOICE3 DATA AREA
	BSR.L NEW_NOTE
	LEA V4DATA(PC),A0		;POINT TO VOICE4 DATA AREA
	BSR.L NEW_NOTE

;PAS_NEW_NOTE2:

NONEWNOTE:
	CLR.W AUDTEMP

	CMP.W	#0,VOICE1SFX		; SAMPLE EN COURS
	BNE	PAS_NEW_EFFET1		; SI OUI ALORS PAS D'EFFETS

	LEA V1DATA(PC),A0
	BSR.L EFFECTS
	MOVE.W D0,(A6)+
	MOVE.W D1,(A6)+
	BRA	RETOUR_EFFET

PAS_NEW_EFFET1:
	ADD.L	#4,A6			; INCREMENTE A6 COMME NORMAL
RETOUR_EFFET:

	LEA V2DATA(PC),A0
	BSR.L EFFECTS
	MOVE.W D0,(A6)+
	MOVE.W D1,(A6)+
	LEA V3DATA(PC),A0
	BSR.L EFFECTS
	MOVE.W D0,(A6)+
	MOVE.W D1,(A6)+
	LEA V4DATA(PC),A0
	BSR.L EFFECTS
	MOVE.W D0,(A6)+
	MOVE.W D1,(A6)+
	LEA PERVOL(PC),A6

	MOVE.W AUDTEMP(PC),D0
	ORI.W #$8000,D0			;SET/CLR BIT = 1

	CMP.W	#0,VOICE1SFX
	BEQ	DONT_TOUCHE

	ORI.W #$0001,D0			; SET EVERY TIME VOICE1

DONT_TOUCHE:

	MOVE.W	D0,$70000

	MOVE.W D0,-(A7)			; DMA

	MOVEQ #0,D1
	MOVE.L START1(PC),D2		;GET SAMPLEPOINTERS
	MOVE.W OFFSET1(PC),D1		;GET OFFSET
	ADD.L D1,D2			;ADD OFFSET
	MOVE.L START2(PC),D3
	MOVE.W OFFSET2(PC),D1
	ADD.L D1,D3
	MOVE.L START3(PC),D4
	MOVE.W OFFSET3(PC),D1
	ADD.L D1,D4
	MOVE.L START4(PC),D5
	MOVE.W OFFSET4(PC),D1
	ADD.L D1,D5
	MOVE.W SSIZE1(PC),D0		;GET SOUND LENGTHS
	MOVE.W SSIZE2(PC),D1
	MOVE.W SSIZE3(PC),D6
	MOVE.W SSIZE4(PC),D7

	MOVE.W (A7)+,$DFF096		;ENABLE AUDIO DMA

	CMP.W	#1,OK_PLAY
	BNE	CONT_OK
	BSR	PLAY_DIGIT
CONT_OK:

CHAN1:	CMP.W	#0,VOICE1SFX
	BNE	PAS_CHAN1	

	LEA V1DATA(PC),A0
	TST.W 72(A0)
	BEQ.L CHAN2
	SUBQ.W #1,72(A0)
	CMPI.W #1,72(A0)
	BNE.S CHAN2
	CLR.W 72(A0)

	MOVE.L D2,$DFF0A0		;SET SOUNDSTART
	MOVE.W D0,$DFF0A4		;SET SOUNDLENGTH
PAS_CHAN1:

CHAN2:	LEA V2DATA(PC),A0
	TST.W 72(A0)
	BEQ.S CHAN3
	SUBQ.W #1,72(A0)
	CMPI.W #1,72(A0)
	BNE.S CHAN3
	CLR.W 72(A0)

	MOVE.L D3,$DFF0B0
	MOVE.W D1,$DFF0B4

CHAN3:	LEA V3DATA(PC),A0
	TST.W 72(A0)
	BEQ.S CHAN4
	SUBQ.W #1,72(A0)
	CMPI.W #1,72(A0)
	BNE.S CHAN4
	CLR.W 72(A0)

	MOVE.L D4,$DFF0C0
	MOVE.W D6,$DFF0C4

CHAN4:	LEA V4DATA(PC),A0
	TST.W 72(A0)
	BEQ.S SETPERVOL
	SUBQ.W #1,72(A0)
	CMPI.W #1,72(A0)
	BNE.S SETPERVOL
	CLR.W 72(A0)

	MOVE.L D5,$DFF0D0
	MOVE.W D7,$DFF0D4

SETPERVOL:

	LEA $DFF0A6,A5

	CMP.W	#0,VOICE1SFX
	BNE	PAS_VOL_PERIODE

	MOVE.W (A6)+,(A5)	;SET PERIOD
	MOVE.W (A6)+,2(A5)	;SET VOLUME
	BRA	PERIODE_RETURN	

PAS_VOL_PERIODE:
	ADD.L	#4,A6
PERIODE_RETURN:

	MOVE.W (A6)+,16(A5)
	MOVE.W (A6)+,18(A5)

	MOVE.W (A6)+,32(A5)
	MOVE.W (A6)+,34(A5)

	MOVE.W (A6)+,48(A5)
	MOVE.W (A6)+,50(A5)
RTS
;---------------------------------------------------------------
NEW_NOTE:
	MOVEQ #0,D5
	MOVE.L 34(A0),A1
	ADDA.W 40(A0),A1

	CMP.W #64,40(A0)
	BNE.L SAMEPAT

	MOVE.L (A0),A2
	ADDA.W 6(A0),A2		;POINT TO NEXT SEQUENCE ROW
	CMPA.L 52(A0),A2	;IS IT THE END?
	BNE.S NOTEND
	MOVE.W D5,6(A0)		;YES!
	MOVE.L (A0),A2		;POINT TO FIRST SEQUENCE
NOTEND:	MOVEQ #0,D1
	ADDQ.B #1,SPDTEMP
	CMPI.B #4,SPDTEMP
	BNE.S NONEWSPD
	MOVE.B D5,SPDTEMP
	MOVE.B -1(A1),D1	;GET NEW REPLAY SPEED
	BEQ.S NONEWSPD
	MOVE.W D1,RESPCNT	;STORE IN COUNTER
	MOVE.W D1,REPSPD
NONEWSPD:
	MOVE.B (A2),D1		;PATTERN TO PLAY
	MOVE.B 1(A2),44(A0)	;TRANSPOSE VALUE
	MOVE.B 2(A2),22(A0)	;SOUNDTRANSPOSE VALUE
	MOVE.W D5,40(A0)
	LSL.W #6,D1
	ADD.L PATPOINT(PC),D1	;GET PATTERN POINTER
	MOVE.L D1,34(A0)
	ADDI.W #$000D,6(A0)
	MOVE.L D1,A1
SAMEPAT:

	MOVE.B 1(A1),D1		;GET INFO BYTE
	MOVE.B (A1)+,D0		;GET NOTE

	BNE.S WW1
	ANDI.W #%11000000,D1
	BEQ.S NOPORT
	BRA.S WW11
	WW1:
	MOVE.W D5,56(A0)
	WW11:
	MOVE.B D5,47(A0)
	MOVE.B (A1),31(A0)
T_PORTON:
	BTST #7,D1
	BEQ.S NOPORT
	MOVE.B 2(A1),47(A0)	
NOPORT:	ANDI.W #$007F,D0
	BEQ.L NEXTNOTE
	MOVE.B D0,8(A0)
	MOVE.B (A1),9(A0)

	CMP.B	#1,32(A0)
	BEQ	NEXT_VOICE

	MOVE.B 32(A0),D2
	MOVEQ #0,D3

	BSET D2,D3

	OR.W D3,AUDTEMP

	MOVE.W D3,$DFF096	; RESET SAMPLE EN COURS

NEXT_VOICE:

	MOVE.B (A1),D1
	ANDI.W #$003F,D1	;MAX 64 INSTRUMENTS

	ADD.B 22(A0),D1
	MOVE.L VOLPOINT(PC),A2
	LSL.W #6,D1
	ADDA.W D1,A2
	MOVE.W D5,16(A0)
	MOVE.B (A2),23(A0)
	MOVE.B (A2)+,24(A0)
	MOVE.B (A2)+,D1
	ANDI.W #$00FF,D1
	MOVE.B (A2)+,27(A0)
	MOVE.B #$40,46(A0)
	MOVE.B (A2)+,D0
	MOVE.B D0,28(A0)
	MOVE.B D0,29(A0)
	MOVE.B (A2)+,30(A0)
	MOVE.L A2,10(A0)
	MOVE.L FRQPOINT(PC),A2
	LSL.W #6,D1
	ADDA.W D1,A2
	MOVE.L A2,18(A0)
	MOVE.W D5,50(A0)
	MOVE.B D5,26(A0)
	MOVE.B D5,25(A0)
NEXTNOTE:
	ADDQ.W 	#2,40(A0)
RTS

EFFECTS:
	MOVEQ 	#0,D7
TESTSUSTAIN:
	TST.B 	26(A0)		;IS SUSTAIN COUNTER = 0
	BEQ.S 	SUSTZERO
	SUBQ.B 	#1,26(A0)	;IF NO, DECREASE COUNTER
	BRA.L 	VOLUFX
SUSTZERO:		;NEXT PART OF EFFECT SEQUENCE
	MOVE.L 	18(A0),A1	;CAN BE EXECUTED NOW.
	ADDA.W 	50(A0),A1
TESTEFFECTS:
	CMPI.B 	#$E1,(A1)	;E1 = END OF FREQSEQ SEQUENCE
	BEQ.L 	VOLUFX
	CMPI.B 	#$E0,(A1)	;E0 = LOOP TO OTHER PART OF SEQUENCE
	BNE.S 	TESTNEWSOUND
	MOVE.B 	1(A1),D0		;LOOP TO START OF SEQUENCE + 1(A1)
	ANDI.W 	#$003F,D0
	MOVE.W 	D0,50(A0)
	MOVE.L 	18(A0),A1
	ADDA.W 	D0,A1
TESTNEWSOUND:
	CMPI.B 	#$E2,(A1)	;E2 = SET WAVEFORM
	BNE.L 	O49C64
	MOVEQ 	#0,D0
	MOVEQ 	#0,D1



	;CMP.B	#1,32(A0)
	;BEQ	NEXT_VOICE1

	MOVE.B 	32(A0),D1
	BSET 	D1,D0

	OR.W 	D0,AUDTEMP

	MOVE.W 	D0,$DFF096

	;NEXT_VOICE1:

	MOVE.B 	1(A1),D0
	ANDI.W 	#$00FF,D0
	LEA 	SOUNDINFO(PC),A4
	ADD.W 	D0,D0
	MOVE.W 	D0,D1
	ADD.W 	D1,D1
	ADD.W 	D1,D1
	ADD.W 	D1,D0
	ADDA.W 	D0,A4
	MOVE.L 	60(A0),A3
	MOVE.L 	(A4),D1
	ADD.L 	#WAVEFORMS,D1
	MOVE.L 	D1,(A3)
	MOVE.L 	D1,68(A0)
	MOVE.W 	4(A4),4(A3)
	MOVE.L 	6(A4),64(A0)
	SWAP D1
	MOVE.W 	#$0003,72(A0)
	TST.W D1
	BNE.S O49C52
	MOVE.W #$0002,72(A0)
O49C52:	CLR.W 16(A0)
	MOVE.B #$01,23(A0)
	ADDQ.W #2,50(A0)
	BRA.L O49D02
O49C64:	CMPI.B #$E4,(A1)
	BNE.S TESTPATJMP
	MOVE.B 1(A1),D0
	ANDI.W #$00FF,D0
	LEA SOUNDINFO(PC),A4
	ADD.W D0,D0
	MOVE.W D0,D1
	ADD.W D1,D1
	ADD.W D1,D1
	ADD.W D1,D0
	ADDA.W D0,A4
	MOVE.L 60(A0),A3
	MOVE.L (A4),D1
	ADD.L #WAVEFORMS,D1
	MOVE.L D1,(A3)
	MOVE.L D1,68(A0)
	MOVE.W 4(A4),4(A3)
	MOVE.L 6(A4),64(A0)
	SWAP D1
	MOVE.W #$0003,72(A0)
	TST.W D1
	BNE.S O49CAE
	MOVE.W #$0002,72(A0)
O49CAE:	ADDQ.W #2,50(A0)
	BRA.S O49D02
TESTPATJMP:
	CMPI.B #$E7,(A1)
	BNE.S TESTNEWSUSTAIN
	MOVE.B 1(A1),D0
	ANDI.W #$00FF,D0
	LSL.W #6,D0
	MOVE.L FRQPOINT(PC),A1
	ADDA.W D0,A1
	MOVE.L A1,18(A0)
	MOVE.W D7,50(A0)
	BRA.L TESTEFFECTS
TESTNEWSUSTAIN:
	CMPI.B #$E8,(A1)	;E8 = SET SUSTAIN TIME
	BNE.S O49CEA
	MOVE.B 1(A1),26(A0)
	ADDQ.W #2,50(A0)
	BRA.L TESTSUSTAIN
O49CEA:	CMPI.B #$E3,(A1)
	BNE.S O49D02
	ADDQ.W #3,50(A0)
	MOVE.B 1(A1),27(A0)
	MOVE.B 2(A1),28(A0)
O49D02:	MOVE.L 18(A0),A1
	ADDA.W 50(A0),A1
	MOVE.B (A1),43(A0)
	ADDQ.W #1,50(A0)
VOLUFX:	TST.B 25(A0)
	BEQ.S O49D1E
	SUBQ.B #1,25(A0)
	BRA.S O49D70
O49D1E:	SUBQ.B #1,23(A0)
	BNE.S O49D70
	MOVE.B 24(A0),23(A0)
O49D2A:	MOVE.L 10(A0),A1
	ADDA.W 16(A0),A1
	MOVE.B (A1),D0
	CMPI.B #$E8,D0
	BNE.S O49D4A
	ADDQ.W #2,16(A0)
	MOVE.B 1(A1),25(A0)
	BRA.S VOLUFX
O49D4A:	CMPI.B #$E1,D0
	BEQ.S O49D70
	CMPI.B #$E0,D0
	BNE.S O49D68
	MOVE.B 1(A1),D0
	ANDI.L #$003F,D0
	SUBQ.B #5,D0
	MOVE.W D0,16(A0)
	BRA.S O49D2A
O49D68:	MOVE.B (A1),45(A0)
	ADDQ.W #1,16(A0)
O49D70:	MOVE.B 43(A0),D0
	BMI.S O49D7E
	ADD.B 8(A0),D0
	ADD.B 44(A0),D0
O49D7E:	ANDI.W #$007F,D0
	LEA PERIODS(PC),A1
	ADD.W D0,D0
	MOVE.W D0,D1
	ADDA.W D0,A1
	MOVE.W (A1),D0
	MOVE.B 46(A0),D7
	TST.B 30(A0)
	BEQ.S O49D9E
	SUBQ.B #1,30(A0)
	BRA.S O49DF4
O49D9E:	MOVE.B D1,D5
	MOVE.B 28(A0),D4
	ADD.B D4,D4
	MOVE.B 29(A0),D1
	TST.B D7
	BPL.S O49DB4
	BTST #0,D7
	BNE.S O49DDA
O49DB4:	BTST #5,D7
	BNE.S O49DC8
	SUB.B 27(A0),D1
	BCC.S O49DD6
	BSET #5,D7
	MOVEQ #0,D1
	BRA.S O49DD6
O49DC8:	ADD.B 27(A0),D1
	CMP.B D4,D1
	BCS.S O49DD6
	BCLR #5,D7
	MOVE.B D4,D1
O49DD6:	MOVE.B D1,29(A0)
O49DDA:	LSR.B #1,D4
	SUB.B D4,D1
	BCC.S O49DE4
	SUBI.W #$0100,D1
O49DE4:	ADDI.B #$A0,D5
	BCS.S O49DF2
O49DEA:	ADD.W D1,D1
	ADDI.B #$18,D5
	BCC.S O49DEA
O49DF2:	ADD.W D1,D0
O49DF4:	EORI.B #$01,D7
	MOVE.B D7,46(A0)
	MOVEQ #0,D1
	MOVE.B 47(A0),D1	;GET PORTAVALUE
	BEQ.S A56D0		;0=NO PORTAMENTO
	CMPI.B #$1F,D1
	BLS.S PORTAUP
PORTADOWN: 
	ANDI.W #$1F,D1
	NEG.W D1
PORTAUP:SUB.W D1,56(A0)
A56D0:	ADD.W 56(A0),D0
O49E3E:	CMPI.W #$0070,D0
	BHI.S NN1
	MOVE.W #$0071,D0
NN1:	CMPI.W #$06B0,D0
	BLS.S NN2
	MOVE.W #$06B0,D0
NN2:	MOVEQ #0,D1
	MOVE.B 45(A0),D1
RTS

PERVOL: BLK.B 16,0	;PERIODS & VOLUMES TEMP. STORE
RESPCNT: DC.W 0		;REPLAY SPEED COUNTER 
REPSPD:  DC.W 0		;REPLAY SPEED COUNTER TEMP
ONOFF:   DC.W 0		;MUSIC ON/OFF FLAG.
FIRSEQ:	 DC.W 0		;FIRST SEQUENCE
LASSEQ:	 DC.W 0		;LAST SEQUENCE
AUDTEMP: DC.W 0
SPDTEMP: DC.W 0
V1DATA:  BLK.B 64,0	;VOICE 1 DATA AREA
OFFSET1: BLK.B 02,0	;IS ADDED TO START OF SOUND
SSIZE1:  BLK.B 02,0	;LENGTH OF SOUND
START1:  BLK.B 06,0	;START OF SOUND
V2DATA:  BLK.B 64,0	;VOICE 2 DATA AREA
OFFSET2: BLK.B 02,0
SSIZE2:  BLK.B 02,0
START2:  BLK.B 06,0
V3DATA:  BLK.B 64,0	;VOICE 3 DATA AREA
OFFSET3: BLK.B 02,0
SSIZE3:  BLK.B 02,0
START3:  BLK.B 06,0
V4DATA:  BLK.B 64,0	;VOICE 4 DATA AREA
OFFSET4: BLK.B 02,0
SSIZE4:  BLK.B 02,0
START4:  BLK.B 06,0
O4A0C8: DC.L $00000000,$00100003,$00200006,$00300009
SEQPOINT: DC.L 0
PATPOINT: DC.L 0
FRQPOINT: DC.L 0
VOLPOINT: DC.L 0
EVEN
SILENT: DC.W $0100,$0000,$0000,$00E1

;---------------------------------------------------------------
; 		DATAS COULEURS POUR LIGNES ET DECALAGES
;---------------------------------------------------------------

;---------------------------------------------------------------
;		COULEURS SCROLL 1 ,RATSER DU HAUT 
;---------------------------------------------------------------
D_COLOR:
		DC.W	$0000,$0011,$0022,$0033,$0044,$0055,$0066
		DC.W	$0077,$0088,$0099,$00AA,$00BB,$00CC,$00EE
		DC.W	$00FF,$00EE,$00CC,$00BB,$00AA,$0099,$0088
		DC.W	$0077,$0066,$0055,$0044,$0033,$0022,$0011
		DC.W	$FFFF

;---------------------------------------------------------------
;		COULEURS SCROLL 1 , RATSER DU BAS
;---------------------------------------------------------------
D_COLOR1:

		DC.W	$0000,$0011,$0022,$0033,$0044,$0055,$0066
		DC.W	$0077,$0088,$0099,$00AA,$00BB,$00CC,$00EE
		DC.W	$00FF,$00EE,$00CC,$00BB,$00AA,$0099,$0088
		DC.W	$0077,$0066,$0055,$0044,$0033,$0022,$0011
		DC.W	$FFFF

;---------------------------------------------------------------
;		COULEURS DU RASTER HAUT DU 2 EME SCROLL
;---------------------------------------------------------------
D_COLOR2:
		DC.W	$0000,$0111,$0222,$0333,$0444,$0555,$0666
		DC.W	$0777,$0888,$0999,$0AAA,$0BBB,$0CCC,$0EEE
		DC.W	$0FFF,$0EEE,$0CCC,$0BBB,$0AAA,$0999,$0888
		DC.W	$0777,$0666,$0555,$0444,$0333,$0222,$0111
		DC.W	$FFFF

;---------------------------------------------------------------
;		COULEURS DU RASTER BAS DU 2 EME SCROLL
;---------------------------------------------------------------
D_COLOR3:
		DC.W	$0000,$0111,$0222,$0333,$0444,$0555,$0666
		DC.W	$0777,$0888,$0999,$0AAA,$0BBB,$0CCC,$0EEE
		DC.W	$0FFF,$0EEE,$0CCC,$0BBB,$0AAA,$0999,$0888
		DC.W	$0777,$0666,$0555,$0444,$0333,$0222,$0111
		DC.W	$FFFF

;---------------------------------------------------------------
; 	SCROOL DE COULEURS POUR LE TEXTE CENTRAL.
;---------------------------------------------------------------
D_COLORC:
BLK.B 2468
		DC.W	$FFFF
;---------------------------------------------------------------
;	DECALAGE POUR TEXTE CENTRAL.
;---------------------------------------------------------------
D_COLORD:
;	DC.W	0,0,0,0,0,1,1,1,1,1,1,1,1,2,2,2,2,2,2,2,2,2,
;	DC.W	1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1
;	DC.W	2,2,2,2,2,3,3,3,3,3,4,4,4,4,4,3,3,3,3,3,2,2,2,2,2
;	DC.W	1,1,1,1,1,0,0,0,0,0,1,1,1,1,2,2,2,3,3,2,2,2,1,1,1,1
;	DC.W	0,1,2,3,4,5,6,7

	DC.W	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	DC.W	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	DC.W	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	DC.W	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	DC.W	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	DC.W	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	DC.W	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	DC.W	1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,14,13,12,11,10,9,8
	DC.W	7,6,5,4,3,2,1,0,0,0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15
	DC.W	14,13,12,11,10,9,8,7,6,5,4,3,2,1
	DC.W	1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,14,13,12,11,10,9,8
	DC.W	7,6,5,4,3,2,1,0,0,0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15
	DC.W	14,13,12,11,10,9,8,7,6,5,4,3,2,1,0,0,0,0,0,0,0,0,0,0,0
	DC.W	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	DC.W	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	DC.W	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	DC.W	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	DC.W	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	DC.W	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,3,4,5,4,3,2,1,0

;	DC.W	$7,$7,$7,$8,$8,$8,$8,$8,$8,$8,$9,$9,$9,$A,$A,$B,$B,$C,$C
;	DC.W	$C,$D,$D,$E,$E,$E,$E,$F,$F,$F,$F,$F,$F,$F,$F,$F,$F,$F,$F
;	DC.W	$F,$F,$F,$F,$F,$F,$E,$E,$E,$E,$D,$D,$C,$C,$B,$A,$A
;	DC.W	$9,$9,$9,$8,$8,$8,$8,$8,$7,$7,$7,$6
;	DC.W	$6,$6,$6,$6,$6,$6,$6,$6,$6,$6,$6,$6,$6,$7,$7,$7,$7,$8,$8
        DC.W	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	DC.W	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	DC.W	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	DC.W	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	DC.W	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	DC.W	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	DC.W	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	DC.W	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	DC.W	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	DC.W	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0


	DC.W	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	DC.W	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	DC.W	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	DC.W	1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,14,13,12,11,10,9,8
	DC.W	7,6,5,4,3,2,1,0,0,0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15
	DC.W	14,13,12,11,10,9,8,7,6,5,4,3,2,1,0,0,0,0,0,0,0,0,0,0,0
	DC.W	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	DC.W	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	DC.W	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	DC.W	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	DC.W	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	DC.W	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,3,4,5,4,3,2,1,0
	DC.W	$FFFF
;---------------------------------------------------------------
;	TAMPON OU TOUTE LES VALEURS SONT SCROLLEES.
;---------------------------------------------------------------
T_COLOR:BLK.W	24,0
T_COLOR1:BLK.W	24,0
T_COLOR2:BLK.W	24,0
T_COLOR3:BLK.W	24,0

T_COLORC:BLK.W	480,0
T_COLORD:BLK.W	480,0

;---------------------------------------------------------------
;	DEBUT DE LA COPPER LIST
;---------------------------------------------------------------
COPP:		DC.L	$01006600,$01020000,$01800000,$0182000F,$01920FFF
;---------------------------------------------------------------
		; POINTEUR PLAYFIELD 1 SUR VIDE
		DC.L	$00E00004,$00E2C000,$00E80004,$00EAC000,$00F00004,$00F2C000

		DC.L	$0301FFFE
P1:		DC.L	$00E40004,$00E6C000	;PLANS RESERVE POUR LOGO
P2:		DC.L	$00EC0004,$00EEC000	;2EME PLAYFIELD
P3:		DC.L	$00F40004,$00F6C000	;
;---------------------------------------------------------------
LIGNE1:		DC.L	$2601FFFE,$0182000F,$00E00004,$00E20000
DEC1:		DC.L	$01020000,$01040040

		DC.L	$2735FFFE
COLOR:		DC.L	$01800000,$01800000,$01800000,$01800000,$01800000,$01800000,$01800000,$01800000,$01800000,$01800000
		DC.L	$01800000,$01800000,$01800000,$01800000,$01800000,$01800000,$01800000,$01800000,$01800000,$01800000
		DC.L	$01800000,$01800000,$01800000,$01800000,$01800000
;---------------------------------------------------------------
		DC.L	$2801FFFE,$01820999
		DC.L	$2A01FFFE,$01820aaa
		DC.L	$2B01FFFE,$01820bbb
		DC.L	$2C01FFFE,$01820ccc
		DC.L	$2E01FFFE,$01820ddd
		DC.L	$3001FFFE,$01820eee
		DC.L	$3301FFFE,$01820fff
;---------------------------------------------------------------
		DC.L	$3635FFFE
COLOR1:		DC.L	$01800000,$01800000,$01800000,$01800000,$1800000,$01800000,$01800000,$01800000,$01800000,$01800000
		DC.L	$01800000,$01800000,$01800000,$01800000,$01800000,$01800000,$01800000,$01800000,$01800000,$01800000
		DC.L	$01800000,$01800000,$01800000,$01800000,$01800000
;---------------------------------------------------------------
		; POINTEUR PLAYFIELD 1 SUR VIDE
DC.L	$00E00004,$00E2C000,$00E80004,$00EAC000,$00F00004,$00F2C000
;---------------------------------------------------------------
;	TABLEAU	AFFICHE_CARACTERES
;----------------------------------------------------------------
	DC.L	$3701FFFE,$0180000F,$01080000,$010A0000
	DC.L	$3801FFFE,$01800000,$01001200,$01820FFF
	DC.L	$00E00006,$00E20000
	DC.L	$4701FFFE,$0180000F,$01000200
	DC.L	$4801FFFE,$01800000,$01080006,$010A0006,$01006600
;----------------------------------------------------------------
;	FIN TABLEAU
;----------------------------------------------------------------

;---------------------------------------------------------------
; POINTEUR PLAYFIELD 1 SUR TEXTE CENTRALE (PLAN 1)
		DC.L	$4935FFFE,$00E00004,$00E24F1A,$01820000
;---------------------------------------------------------------
DEG:		BLK.B	$84C,0	; COPPER CONSTRUITE
;---------------------------------------------------------------
		DC.L	$FFE1FFFE
		DC.L	$FFF0FFFE	; WAIT OF 2ND PART OF SCREEN
;---------------------------------------------------------------
		DC.L	$0B35FFFE
COLOR2:		DC.L	$01800000,$01800000,$01800000,$01800000,$01800000,$01800000,$01800000,$01800000,$01800000,$01800000
		DC.L	$01800000,$01800000,$01800000,$01800000,$01800000,$01800000,$01800000,$01800000,$01800000,$01800000
		DC.L	$01800000,$01800000,$01800000,$01800000,$01800000
;---------------------------------------------------------------
LIGNE2:		DC.L	$0D01FFFE,$01820008,$00E00004,$00E2102E
DEC2:		
                DC.L	$01020000,$01040088
		DC.L	$0F01FFFE,$01820099
		DC.L	$1101FFFE,$018200aa
		DC.L	$1301FFFE,$018200bb
		DC.L	$1501FFFE,$018200cc
		DC.L	$1701FFFE,$018200dd
		DC.L	$1901FFFE,$018200ee
;---------------------------------------------------------------
		DC.L	$1F35FFFE
COLOR3:		DC.L	$01800000,$01800000,$01800000,$01800000,$01800000,$01800000,$01800000,$01800000,$01800000,$01800000
		DC.L	$01800000,$01800000,$01800000,$01800000,$01800000,$01800000,$01800000,$01800000,$01800000,$01800000
		DC.L	$01800000,$01800000,$01800000,$01800000,$01800000
;---------------------------------------------------------------
; 		SIGNATURE OF THE MASTER !!! ( EHEH DON'T TRY TO REMOVE !)
;---------------------------------------------------------------
		DC.L	$21E1FFFE,$018E0000,$00E40004,$00E6FF00,$00EC0004,$00EED000,$00F40004,$00F6D000,$01920004
		DC.L	$22E1FFFE,$01920606,$23E1FFFE,$01920808
		DC.L	$24E1FFFE,$01920B0B,$25E1FFFE,$01920D0D
		DC.L	$26E1FFFE,$01920B0B,$27E1FFFE,$01920808
		DC.L	$28E1FFFE,$01920606,$29E1FFFE,$01920404
;---------------------------------------------------------------
		DC.L	$009C8010,$FFFFFFFE	; END COPPER
;---------------------------------------------------------------
CODETABLE:
DC.B "A",0,"B",1,"C",2,"D",3,"E",4,"F",5,"G",6,"H",7,"I",8
DC.B "J",9,"K",10,"L",11,"M",12,"N",13,"O",14,"P",15,"Q",16
DC.B "R",17,"S",18,"T",19,"U",20,"V",21,"W",22,"X",23,"Y",24,"Z",25
DC.B "A",0,"B",1,"C",2,"D",3,"E",4,"F",5,"G",6,"H",7,"I",8
DC.B "J",9,"K",10,"L",11,"M",12,"N",13,"O",14,"P",15,"Q",16
DC.B "R",17,"S",18,"T",19,"U",20,"V",21,"W",22,"X",23,"Y",24,"Z",25
DC.B "0",26,"1",27,"2",28,"3",29,"4",30,"5",31,"6",32,"7",33,"8",34
DC.B "9",35,",",36,"'",37,".",38,":",39,"(",40,")",41,"[",42,"]",43
DC.B "?",44,"!",45,"/",46,"-",47," ",48

DC.B "",$A1,"",$A2,"",$A3,"",$A4,"",$A5,"",$A6

DC.B 255,255
EVEN
ADDRESSE:
	DC.W	0,2,4,6,8,10,12,14,16,18,20,22,24,26,28,30,32,34,36,38,640,642,644,646,648,650,652,654,656,658,660,662,664,666
	DC.W	668,670,672,674,676,678,1280,1282,1284,1286,1288,1290,1292,1294,1296,1300,1302
	DC.W	1304,1306,1308,1310,1312,1314,1318
EVEN
PERIODS:DC.W $06B0,$0650,$05F4,$05A0,$054C,$0500,$04B8,$0474
	DC.W $0434,$03F8,$03C0,$038A,$0358,$0328,$02FA,$02D0
	DC.W $02A6,$0280,$025C,$023A,$021A,$01FC,$01E0,$01C5
	DC.W $01AC,$0194,$017D,$0168,$0153,$0140,$012E,$011D
	DC.W $010D,$00FE,$00F0,$00E2,$00D6,$00CA,$00BE,$00B4
	DC.W $00AA,$00A0,$0097,$008F,$0087,$007F,$0078,$0071
	DC.W $0071,$0071,$0071,$0071,$0071,$0071,$0071,$0071
	DC.W $0071,$0071,$0071,$0071,$0D60,$0CA0,$0BE8,$0B40
	DC.W $0A98,$0A00,$0970,$08E8,$0868,$07F0,$0780,$0714
	DC.W $1AC0,$1940,$17D0,$1680,$1530,$1400,$12E0,$11D0
	DC.W $10D0,$0FE0,$0F00,$0E28
SOUNDINFO:
;OFFSET.L , SOUND-LENGTH.W , START-OFFSET.W , REPEAT-LENGTH.W 
;RESERVED FOR SAMPLES
	DC.W $0000,$0000 ,$0000 ,$0000 ,$0001 
	DC.W $0000,$0000 ,$0000 ,$0000 ,$0001 
	DC.W $0000,$0000 ,$0000 ,$0000 ,$0001 
	DC.W $0000,$0000 ,$0000 ,$0000 ,$0001 
	DC.W $0000,$0000 ,$0000 ,$0000 ,$0001 
	DC.W $0000,$0000 ,$0000 ,$0000 ,$0001 
	DC.W $0000,$0000 ,$0000 ,$0000 ,$0001 
	DC.W $0000,$0000 ,$0000 ,$0000 ,$0001 
	DC.W $0000,$0000 ,$0000 ,$0000 ,$0001 
	DC.W $0000,$0000 ,$0000 ,$0000 ,$0001 
;RESERVED FOR SYNTH SOUNDS
	DC.W $0000,$0000 ,$0010 ,$0000 ,$0010 
	DC.W $0000,$0020 ,$0010 ,$0000 ,$0010 
	DC.W $0000,$0040 ,$0010 ,$0000 ,$0010 
	DC.W $0000,$0060 ,$0010 ,$0000 ,$0010 
	DC.W $0000,$0080 ,$0010 ,$0000 ,$0010 
	DC.W $0000,$00A0 ,$0010 ,$0000 ,$0010 
	DC.W $0000,$00C0 ,$0010 ,$0000 ,$0010 
	DC.W $0000,$00E0 ,$0010 ,$0000 ,$0010 
	DC.W $0000,$0100 ,$0010 ,$0000 ,$0010 
	DC.W $0000,$0120 ,$0010 ,$0000 ,$0010 
	DC.W $0000,$0140 ,$0010 ,$0000 ,$0010 
	DC.W $0000,$0160 ,$0010 ,$0000 ,$0010 
	DC.W $0000,$0180 ,$0010 ,$0000 ,$0010 
	DC.W $0000,$01A0 ,$0010 ,$0000 ,$0010 
	DC.W $0000,$01C0 ,$0010 ,$0000 ,$0010 
	DC.W $0000,$01E0 ,$0010 ,$0000 ,$0010 
	DC.W $0000,$0200 ,$0010 ,$0000 ,$0010 
	DC.W $0000,$0220 ,$0010 ,$0000 ,$0010 
	DC.W $0000,$0240 ,$0010 ,$0000 ,$0010 
	DC.W $0000,$0260 ,$0010 ,$0000 ,$0010 
	DC.W $0000,$0280 ,$0010 ,$0000 ,$0010 
	DC.W $0000,$02A0 ,$0010 ,$0000 ,$0010 
	DC.W $0000,$02C0 ,$0010 ,$0000 ,$0010 
	DC.W $0000,$02E0 ,$0010 ,$0000 ,$0010 
	DC.W $0000,$0300 ,$0010 ,$0000 ,$0010 
	DC.W $0000,$0320 ,$0010 ,$0000 ,$0010 
	DC.W $0000,$0340 ,$0010 ,$0000 ,$0010 
	DC.W $0000,$0360 ,$0010 ,$0000 ,$0010 
	DC.W $0000,$0380 ,$0010 ,$0000 ,$0010 
	DC.W $0000,$03A0 ,$0010 ,$0000 ,$0010 
	DC.W $0000,$03C0 ,$0010 ,$0000 ,$0010 
	DC.W $0000,$03E0 ,$0010 ,$0000 ,$0010 
	DC.W $0000,$0400 ,$0008 ,$0000 ,$0008 
	DC.W $0000,$0410 ,$0008 ,$0000 ,$0008 
	DC.W $0000,$0420 ,$0008 ,$0000 ,$0008 
	DC.W $0000,$0430 ,$0008 ,$0000 ,$0008 
	DC.W $0000,$0440 ,$0008 ,$0000 ,$0008
	DC.W $0000,$0450 ,$0008 ,$0000 ,$0008
	DC.W $0000,$0460 ,$0008 ,$0000 ,$0008
	DC.W $0000,$0470 ,$0008 ,$0000 ,$0008
	DC.W $0000,$0480 ,$0010 ,$0000 ,$0010
	DC.W $0000,$04A0 ,$0008 ,$0000 ,$0008
	DC.W $0000,$04B0 ,$0010 ,$0000 ,$0010
	DC.W $0000,$04D0 ,$0010 ,$0000 ,$0010
	DC.W $0000,$04F0 ,$0008 ,$0000 ,$0008
	DC.W $0000,$0500 ,$0008 ,$0000 ,$0008
	DC.W $0000,$0510 ,$0018 ,$0000 ,$0018
WAVEFORMS:
DC.W $C0C0,$D0D8,$E0E8,$F0F8,$00F8,$F0E8,$E0D8,$D0C8
DC.W $3F37,$2F27,$1F17,$0F07,$FF07,$0F17,$1F27,$2F37
DC.W $C0C0,$D0D8,$E0E8,$F0F8,$00F8,$F0E8,$E0D8,$D0C8
DC.W $C037,$2F27,$1F17,$0F07,$FF07,$0F17,$1F27,$2F37
DC.W $C0C0,$D0D8,$E0E8,$F0F8,$00F8,$F0E8,$E0D8,$D0C8
DC.W $C0B8,$2F27,$1F17,$0F07,$FF07,$0F17,$1F27,$2F37
DC.W $C0C0,$D0D8,$E0E8,$F0F8,$00F8,$F0E8,$E0D8,$D0C8
DC.W $C0B8,$B027,$1F17,$0F07,$FF07,$0F17,$1F27,$2F37
DC.W $C0C0,$D0D8,$E0E8,$F0F8,$00F8,$F0E8,$E0D8,$D0C8
DC.W $C0B8,$B0A8,$1F17,$0F07,$FF07,$0F17,$1F27,$2F37
DC.W $C0C0,$D0D8,$E0E8,$F0F8,$00F8,$F0E8,$E0D8,$D0C8
DC.W $C0B8,$B0A8,$A017,$0F07,$FF07,$0F17,$1F27,$2F37
DC.W $C0C0,$D0D8,$E0E8,$F0F8,$00F8,$F0E8,$E0D8,$D0C8
DC.W $C0B8,$B0A8,$A098,$0F07,$FF07,$0F17,$1F27,$2F37
DC.W $C0C0,$D0D8,$E0E8,$F0F8,$00F8,$F0E8,$E0D8,$D0C8
DC.W $C0B8,$B0A8,$A098,$9007,$FF07,$0F17,$1F27,$2F37
DC.W $C0C0,$D0D8,$E0E8,$F0F8,$00F8,$F0E8,$E0D8,$D0C8
DC.W $C0B8,$B0A8,$A098,$9088,$FF07,$0F17,$1F27,$2F37
DC.W $C0C0,$D0D8,$E0E8,$F0F8,$00F8,$F0E8,$E0D8,$D0C8
DC.W $C0B8,$B0A8,$A098,$9088,$8007,$0F17,$1F27,$2F37
DC.W $C0C0,$D0D8,$E0E8,$F0F8,$00F8,$F0E8,$E0D8,$D0C8
DC.W $C0B8,$B0A8,$A098,$9088,$8088,$0F17,$1F27,$2F37
DC.W $C0C0,$D0D8,$E0E8,$F0F8,$00F8,$F0E8,$E0D8,$D0C8
DC.W $C0B8,$B0A8,$A098,$9088,$8088,$9017,$1F27,$2F37
DC.W $C0C0,$D0D8,$E0E8,$F0F8,$00F8,$F0E8,$E0D8,$D0C8
DC.W $C0B8,$B0A8,$A098,$9088,$8088,$9098,$1F27,$2F37
DC.W $C0C0,$D0D8,$E0E8,$F0F8,$00F8,$F0E8,$E0D8,$D0C8
DC.W $C0B8,$B0A8,$A098,$9088,$8088,$9098,$A027,$2F37
DC.W $C0C0,$D0D8,$E0E8,$F0F8,$00F8,$F0E8,$E0D8,$D0C8
DC.W $C0B8,$B0A8,$A098,$9088,$8088,$9098,$A0A8,$2F37
DC.W $C0C0,$D0D8,$E0E8,$F0F8,$00F8,$F0E8,$E0D8,$D0C8
DC.W $C0B8,$B0A8,$A098,$9088,$8088,$9098,$A0A8,$B037
DC.W $8181,$8181,$8181,$8181,$8181,$8181,$8181,$8181
DC.W $7F7F,$7F7F,$7F7F,$7F7F,$7F7F,$7F7F,$7F7F,$7F7F
DC.W $8181,$8181,$8181,$8181,$8181,$8181,$8181,$8181
DC.W $817F,$7F7F,$7F7F,$7F7F,$7F7F,$7F7F,$7F7F,$7F7F
DC.W $8181,$8181,$8181,$8181,$8181,$8181,$8181,$8181
DC.W $8181,$7F7F,$7F7F,$7F7F,$7F7F,$7F7F,$7F7F,$7F7F
DC.W $8181,$8181,$8181,$8181,$8181,$8181,$8181,$8181
DC.W $8181,$817F,$7F7F,$7F7F,$7F7F,$7F7F,$7F7F,$7F7F
DC.W $8181,$8181,$8181,$8181,$8181,$8181,$8181,$8181
DC.W $8181,$8181,$7F7F,$7F7F,$7F7F,$7F7F,$7F7F,$7F7F
DC.W $8181,$8181,$8181,$8181,$8181,$8181,$8181,$8181
DC.W $8181,$8181,$817F,$7F7F,$7F7F,$7F7F,$7F7F,$7F7F
DC.W $8181,$8181,$8181,$8181,$8181,$8181,$8181,$8181
DC.W $8181,$8181,$8181,$7F7F,$7F7F,$7F7F,$7F7F,$7F7F
DC.W $8181,$8181,$8181,$8181,$8181,$8181,$8181,$8181
DC.W $8181,$8181,$8181,$817F,$7F7F,$7F7F,$7F7F,$7F7F
DC.W $8181,$8181,$8181,$8181,$8181,$8181,$8181,$8181
DC.W $8181,$8181,$8181,$8181,$7F7F,$7F7F,$7F7F,$7F7F
DC.W $8181,$8181,$8181,$8181,$8181,$8181,$8181,$8181
DC.W $8181,$8181,$8181,$8181,$817F,$7F7F,$7F7F,$7F7F
DC.W $8181,$8181,$8181,$8181,$8181,$8181,$8181,$8181
DC.W $8181,$8181,$8181,$8181,$8181,$7F7F,$7F7F,$7F7F
DC.W $8181,$8181,$8181,$8181,$8181,$8181,$8181,$8181
DC.W $8181,$8181,$8181,$8181,$8181,$817F,$7F7F,$7F7F
DC.W $8181,$8181,$8181,$8181,$8181,$8181,$8181,$8181
DC.W $8181,$8181,$8181,$8181,$8181,$8181,$7F7F,$7F7F
DC.W $8181,$8181,$8181,$8181,$8181,$8181,$8181,$8181
DC.W $8181,$8181,$8181,$8181,$8181,$8181,$817F,$7F7F
DC.W $8080,$8080,$8080,$8080,$8080,$8080,$8080,$8080
DC.W $8080,$8080,$8080,$8080,$8080,$8080,$8080,$7F7F
DC.W $8080,$8080,$8080,$8080,$8080,$8080,$8080,$8080
DC.W $8080,$8080,$8080,$8080,$8080,$8080,$8080,$807F
DC.W $8080,$8080,$8080,$8080,$7F7F,$7F7F,$7F7F,$7F7F
DC.W $8080,$8080,$8080,$807F,$7F7F,$7F7F,$7F7F,$7F7F
DC.W $8080,$8080,$8080,$7F7F,$7F7F,$7F7F,$7F7F,$7F7F
DC.W $8080,$8080,$807F,$7F7F,$7F7F,$7F7F,$7F7F,$7F7F
DC.W $8080,$8080,$7F7F,$7F7F,$7F7F,$7F7F,$7F7F,$7F7F
DC.W $8080,$807F,$7F7F,$7F7F,$7F7F,$7F7F,$7F7F,$7F7F
DC.W $8080,$7F7F,$7F7F,$7F7F,$7F7F,$7F7F,$7F7F,$7F7F
DC.W $8080,$7F7F,$7F7F,$7F7F,$7F7F,$7F7F,$7F7F,$7F7F
DC.W $8080,$9098,$A0A8,$B0B8,$C0C8,$D0D8,$E0E8,$F0F8
DC.W $0008,$1018,$2028,$3038,$4048,$5058,$6068,$707F
DC.W $8080,$A0B0,$C0D0,$E0F0,$0010,$2030,$4050,$6070
DC.W $4545,$797D,$7A77,$7066,$6158,$534D,$2C20,$1812
DC.W $04DB,$D3CD,$C6BC,$B5AE,$A8A3,$9D99,$938E,$8B8A
DC.W $4545,$797D,$7A77,$7066,$5B4B,$4337,$2C20,$1812
DC.W $04F8,$E8DB,$CFC6,$BEB0,$A8A4,$9E9A,$9594,$8D83
DC.W $0000,$4060,$7F60,$4020,$00E0,$C0A0,$80A0,$C0E0
DC.W $0000,$4060,$7F60,$4020,$00E0,$C0A0,$80A0,$C0E0
DC.W $8080,$9098,$A0A8,$B0B8,$C0C8,$D0D8,$E0E8,$F0F8
DC.W $0008,$1018,$2028,$3038,$4048,$5058,$6068,$707F
DC.W $8080,$A0B0,$C0D0,$E0F0,$0010,$2030,$4050,$6070
;----------------------------------------------------------------
little_font:
;---------------------------------------------------------------
	dc.b 	$00,$00,$00,$00,$00,$00,$00,$00		; Space
	dc.b 	$00,$18,$18,$18,$18,$18,$00,$18		; !
	dc.b 	$00,$6c,$6c,$00,$00,$00,$00,$00		; "
	dc.b 	$00,$36,$7f,$36,$36,$7f,$36,$00		; #
	dc.b 	$00,$08,$3c,$68,$3c,$16,$7c,$10		; $
	dc.b 	$00,$00,$66,$6c,$18,$36,$66,$00		; %
	dc.b 	$00,$1c,$36,$1c,$3f,$66,$7b,$00		; &	
	dc.b 	$0c,$18,$30,$00,$00,$00,$00,$00		; '
	dc.b 	$00,$03,$06,$0c,$0c,$0c,$06,$03		; (
	dc.b 	$00,$60,$30,$18,$18,$18,$30,$60		; )
	dc.b 	$00,$18,$42,$18,$7e,$18,$42,$18		; *
	dc.b 	$00,$00,$1c,$1c,$7f,$1c,$1c,$00		; +
	dc.b 	$00,$00,$00,$00,$00,$30,$30,$60		; ,
	dc.b 	$00,$00,$00,$00,$7f,$00,$00,$00		; -
	dc.b 	$00,$00,$00,$00,$00,$30,$30,$00		; .
	dc.b 	$00,$00,$03,$06,$0c,$18,$30,$60		; /
	dc.b 	$00,$00,$7f,$63,$63,$63,$7f,$00		; 0
	dc.b 	$00,$00,$3c,$0c,$0c,$0c,$0c,$1e		; 1
	dc.b 	$00,$00,$7f,$03,$7f,$70,$7f,$00		; 2
	dc.b 	$00,$00,$7f,$03,$1f,$03,$7f,$00		; 3
	dc.b 	$70,$70,$76,$76,$7f,$06,$06,$00		; 4
	dc.b 	$00,$00,$7f,$70,$7e,$07,$7e,$00		; 5
	dc.b 	$70,$70,$70,$70,$7f,$73,$7f,$00		; 6
	dc.b 	$00,$00,$7f,$03,$03,$03,$03,$03		; 7
	dc.b 	$00,$00,$7f,$73,$7f,$73,$7f,$00		; 8
	dc.b 	$00,$00,$7f,$73,$7f,$03,$03,$03		; 9
	dc.b 	$00,$00,$18,$18,$00,$18,$18,$00		; :
	dc.b 	$00,$00,$18,$18,$00,$18,$18,$30		; ;
	dc.b 	$00,$0c,$18,$30,$60,$30,$18,$0c		; <
	dc.b 	$00,$00,$00,$3c,$00,$3c,$00,$00		; =
	dc.b 	$00,$30,$18,$0c,$06,$0c,$18,$30		; >
	dc.b 	$00,$00,$7f,$63,$0f,$0c,$00,$0c		; ?
	dc.b 	$00,$00,$00,$00,$00,$00,$00,$00		; @
	dc.b 	$00,$00,$ff,$03,$7f,$73,$73,$00		; A
	dc.b 	$00,$00,$fe,$03,$7e,$73,$7e,$00		; B
	dc.b 	$00,$00,$3f,$70,$70,$70,$3f,$00		; C
	dc.b 	$00,$00,$fe,$03,$73,$73,$7e,$00		; D
	dc.b 	$00,$00,$ff,$00,$7f,$70,$7f,$00		; E
	dc.b 	$00,$00,$7f,$00,$7f,$60,$60,$00		; F
	dc.b 	$00,$00,$3f,$70,$73,$73,$3f,$00		; G
	dc.b 	$00,$00,$73,$73,$7f,$73,$73,$70		; H
	dc.b 	$00,$00,$1c,$1c,$1c,$1c,$1c,$00		; I
	dc.b 	$00,$00,$ff,$06,$06,$06,$7e,$00		; J
	dc.b 	$00,$00,$73,$76,$7c,$76,$73,$00		; K
	dc.b 	$00,$70,$70,$70,$70,$70,$7f,$00		; L
	dc.b 	$00,$00,$63,$77,$7f,$6b,$63,$60		; M
	dc.b 	$40,$60,$73,$7b,$7f,$77,$73,$01		; N
	dc.b 	$00,$00,$fe,$03,$63,$63,$3e,$00		; O
	dc.b 	$00,$00,$fe,$03,$7e,$70,$70,$00		; P
	dc.b 	$00,$00,$3e,$63,$63,$6f,$3e,$03		; Q
	dc.b 	$00,$00,$fe,$03,$7e,$66,$63,$00		; R
	dc.b 	$00,$00,$0f,$1c,$1c,$1c,$f8,$00		; S
	dc.b 	$00,$00,$ff,$1c,$1c,$1c,$1c,$00		; T
	dc.b 	$00,$00,$73,$73,$73,$73,$3e,$00		; U
	dc.b 	$00,$00,$73,$73,$73,$3e,$1c,$00		; V
	dc.b 	$03,$03,$63,$6b,$7f,$77,$63,$00		; W
	dc.b 	$00,$00,$73,$73,$3e,$73,$73,$00		; X
	dc.b 	$00,$00,$73,$73,$7f,$1c,$1c,$1c		; Y
	dc.b 	$00,$00,$ff,$0e,$1c,$38,$7f,$00		; Z
	dc.b 	$00,$3c,$38,$38,$38,$38,$38,$3c		; [
	dc.b 	$00,$00,$1f,$38,$fe,$70,$7f,$00		; 
	dc.b 	$00,$3c,$1c,$1c,$1c,$1c,$1c,$3c		; ]
	dc.b 	$00,$18,$3c,$7e,$18,$18,$18,$18		; HARROW UP
	dc.b 	$00,$00,$10,$3f,$7f,$3f,$10,$00		; HARROW LEFT

;----------------------------------------------------------------
DATA:
O:			;BLK.B		280
POL=O+280		;:BLK.B		1960
MODULE=POL+1960		;:BLK.B		42000,0		;TAILLE DU MODULE
DATA1=MODULE+43620
SAMPLE_LAZER=DATA1+3000
;----------------------------------------------------------------
;	POLICE + SIGNATURE DU CHEF CODER ! HIHI
;----------------------------------------------------------------
>EXTERN "RAM:COL",D_COLORC
>EXTERN "RAM:O",O
>EXTERN "RAM:OK3",POL
>EXTERN "RAM:SHORT-LAZER-1.SMP",SAMPLE_LAZER
>EXTERN "RAM:DATA1",MODULE
